﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows.Data;

namespace GridTest2
{
	public class MultiValueEqualityToBooleanConverter : IMultiValueConverter
	{
		public bool IsInverted { get; set; }

		public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
		{
			if (values.Count() < 2)
				return IsInverted ? false : true;

			var result = values.All(obj =>
				{
					if (obj == null && values[0] == null)
						return true;

					if (obj == null || values[0] == null)
						return false;

					return obj.Equals(values[0]);
				}
			);

			if (IsInverted)
				result = !result;

			return result;
		}

		public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
